/*
 * cf.c
 */
#include "cf_file.h"
#include "cf_debug.h"
#include "cf_log.h"
#include "cf_socket.h"
#include "cf_thread.h"

CF_Debug_Ctx		gDebugCtx;
CF_Debug_CallStack	gDebugCallstack;

CF_Log_Ctx			gLogCtx;

void func1 (const char * message)
{
	CF_DEBUG_CALLSTACK_PUSH (gDebugCtx);


	CF_DEBUG_CALLSTACK_POP (gDebugCtx, &gDebugCallstack);
	CF_Log_Write (gLogCtx, "test log",
							"here is the end of function [file:%s line:%d func:%s]\n",
							gDebugCallstack.file,
							gDebugCallstack.line,
							gDebugCallstack.function);
}

int main (int argc, char ** argv)
{
	gDebugCtx	= CF_Debug_CreateCtx ();
	gLogCtx		= CF_Log_CreateCtx ("./log.txt", CF_LOG_BUFFER_DEFAULT);

	if (gDebugCtx == NULL)
	{
		CF_DEBUG_TRACE (gDebugCtx, "create debug ctx error\n");
	}

	if (gLogCtx == NULL)
	{
		CF_DEBUG_TRACE (gDebugCtx, "create log ctx error\n");
	}

	CF_DEBUG_CALLSTACK_PUSH (gDebugCtx);

	func1 ("merong kkkkkkkkkkk");

	CF_DEBUG_CALLSTACK_POP (gDebugCtx, &gDebugCallstack);
	CF_DEBUG_TRACE (gDebugCtx, "here is the end of function [file:%s line:%d func:%s]\n",
								gDebugCallstack.file,
								gDebugCallstack.line,
								gDebugCallstack.function);

	CF_Log_DestroyCtx (gLogCtx);
	CF_Debug_DestroyCtx (gDebugCtx);

	return 0;
}
